<template>
    <div class="input-group">
        <slot v-if="this.$slots['default']"></slot>
        <label v-else-if="label">
            {{ label }}
        </label>
        <div class="input-wrapper">
            <input
                :value="modelValue"
                @input="input"
                :disabled="disabled"
                :type="computedType"
                :placeholder="placeholder"
                :class="{ 'ach-input--error': error }"
                class="ach-input"
            >
            <div class="input-actions">
                <div v-if="visibilityControl" class="input-control" @click="toggleVisibility">
                    <img v-if="isVisible" src="@/assets/icons/eye-crossed.svg" alt="">
                    <img v-else src="@/assets/icons/eye.svg" alt="">
                </div>
                <div v-if="clearable && error" class="input-control" @click="clear">
                    <img src="@/assets/icons/clear.svg" alt="">
                </div>
            </div>
        </div>
    </div>
</template>

<script>
export default {
    name: "CustomInput",
    props: {
        modelValue: {
            type: [String, Number, Boolean],
            default: null
        },
        isVisible: {
            type: Boolean,
            default: false
        },
        type: {
            type: String,
            default: 'text',
            validator: value => {
                return value.match(/(text|number|email|password|tel)/)
            }
        },
        label: {
            type: String,
            default: ''
        },
        placeholder: {
            type: String,
            default: ''
        },
        error: {
            type: Boolean,
            default: false
        },
        disabled: {
            type: Boolean,
            default: false
        },
        visibilityControl: {
            type: Boolean,
            default: false
        },
        clearable: {
            type: Boolean,
            default: false,
        }
    },
    emits: ['update:modelValue'],
    methods: {
        input(event) {
            this.$emit('update:modelValue', event.target.value);
        },
        toggleVisibility() {
            this.$emit('update:isVisible', !this.isVisible);
        },
        clear() {
            this.$emit('update:modelValue', '');
        }
    },
    computed: {
        computedType() {
            return this.isVisible ? 'text' : this.type;
        }
    }
}
</script>

<style scoped lang="scss">
.input-group {
    display: flex;
    flex-direction: column;
}

.input-wrapper {
    position: relative;
    display: flex;
}

.input-group label {
    font-family: 'Inter', sans-serif;
    font-style: normal;
    font-weight: 600;
    font-size: 14px;
    line-height: 17px;

    margin-bottom: 5px;
    color: #FFFFFF;
}

.ach-input {
    width: 100%;

    background: #111827;

    border: 1px solid #9196A7;
    box-sizing: border-box;
    border-radius: 5px;

    color: $x-color-white;

    padding: 20px 16px;

    &:hover {
        border-color: $hsl-color-orange;
    }

    &:focus, &:focus-visible {
        border-color: $hsl-color-orange;
        outline: none;
    }

    &:active {
        border-color: $hsl-color-orange;
    }
}

.input-group input::placeholder {
    font-family: 'Inter', sans-serif;
    font-style: normal;
    font-weight: 500;
    font-size: 14px;
    line-height: 17px;

    color: #9196A7;
}

.input-actions {
    position: absolute;
    right: 16px;
    top: calc(50% - 18px / 2);
    display: flex;
    align-items: center;
}

.input-control {
    cursor: pointer;
    padding-left: 4px;
}

.ach-input--error {
    border-color: $hsl-color-red !important;
    color: $hsl-color-red !important;

    &:hover {
        border-color: $hsl-color-red !important;
    }

    &:focus {
        border-color: $hsl-color-red !important;
    }

    &:active {
        border-color: $hsl-color-red !important;
    }
}
</style>